/**
Interface AgentEventListener: Any class wishing to receive agent events must implement this interface
*/
public interface AgentEventListener extends java.util.EventListener
{
	// Event thrown when Agent Identity object arrives
	public void agentIdentityArrived(AgentEvent evt);

	// Agent is authenticated
	public void agentAuthenticated(AgentEvent evt);

	// Agent arrival
	public void agentArrived(AgentEvent evt);

	// Agent "start" method is called to start the agent thread
	public void agentStarted(AgentEvent evt);

	// Agent is stopped and ready to be dispatched to the next host destination
	public void agentStopped(AgentEvent evt);

	// Agent Authentication failed
	public void agentAuthenticationFailed(AgentEvent evt);
}