/**
Class ErrorDialog:
Displays error message as well as the receiver events graphically
*/


import java.awt.*;
import java.awt.event.*;
import java.awt.swing.*;
import java.awt.swing.event.*;

public class ErrorDialog extends JDialog implements ActionListener
{
	AgentServerGUI gui;
	String message;
	Container c;
	boolean showChoice=false;
	

	// constructor
	public ErrorDialog(AgentServerGUI gui, String message, int x, int y, boolean showChoice)
	{
		super(gui, "Message Window", true);
		JLabel label1=null;
		JLabel label2=null;
		JLabel label3=null;
		Font font = new Font("Serif", Font.BOLD , 12); 
		Font font1=new Font("Serif", Font.BOLD| Font.ITALIC , 18);
		Font font2=new Font("Serif", Font.BOLD, 24);
		this.message=message;
		this.gui=gui;
		c=getContentPane();
		setSize(x,y);
		
		System.out.println("CHOICE:"+showChoice);
		JLabel label=new JLabel(message);
		if (showChoice)
		{
			c.setLayout(new GridLayout(6,1));
			label1=new JLabel("Received Agent From:");
			label1.setFont(font1);
			c.add(label1);
			label.setFont(font2);
			System.out.println("In Here!");
			c.add(label);
			label2=new JLabel("Authentication and verification done.");
			label2.setFont(font1);
			c.add(label2);
			label3=new JLabel("Do you want to start agent thread?");
			label3.setFont(font1);
			c.add(label3);
			
		}
		else
		{
			c.setLayout(new FlowLayout());
			ImageIcon errorIcon = new ImageIcon("error.gif"); 
			label.setIcon(errorIcon);
			label.setFont(font1);
			label.setHorizontalAlignment(JLabel.LEFT); 
			c.add(label);
		}



		JButton ok=new JButton("OK");
		ok.setBackground(SystemColor.control);
		ok.setActionCommand("OK");
		ok.addActionListener(this);
		c.add(ok);

		JButton no=new JButton("NO");
		no.setBackground(SystemColor.control);
		no.addActionListener(this);
		no.setActionCommand("NO");

		if (showChoice)
			c.add(no);
		show();
	}

	public void actionPerformed(ActionEvent evt)
	{
		String cmmd=evt.getActionCommand();
		if (cmmd.equals("OK"))
		{
			gui.acceptAgent=true;
			this.dispose();
		}

		else if (cmmd.equals("NO"))
		{
			gui.acceptAgent=false;
			this.dispose();
		}
	}
}





	



