/**
class : InAgentListBox
Class which handles the display and insertion/deletion of the names in the list boxes for the incoming and ready agents
*/
import java.awt.swing.*;
import java.awt.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.swing.border.*;


public class InAgentListBox extends JList implements MouseListener
{

	private DefaultListModel dmodel;
	AgentServerGUI gui;

	// constructor
	public InAgentListBox(AgentServerGUI gui)
	{
		super();
		this.gui=gui;
		dmodel=new DefaultListModel();
		setModel(dmodel);
		addMouseListener(this);
		setBorder(BorderFactory.createTitledBorder("Incoming Agents"));
	}

	public void addAgentName(String agentName)
	{
		dmodel.addElement(agentName);
	}

	public void removeAgentName(String agentName)
	{
		String name;

		try
		{
			for (int i=0;i<dmodel.getSize();i++)
			{
				name=(String) dmodel.getElementAt(i);
				if (name.equals(agentName));
				dmodel.removeElementAt(i);
				break;
			}
		}
		catch (ArrayIndexOutOfBoundsException e)
		{
			System.out.println("Array Index Exception caught");
		}
	}

	public void mouseClicked(MouseEvent evt)
	{
		int index = locationToIndex(evt.getPoint());
		if (index!=-1 && (evt.getClickCount()==2))
				System.out.println("Clicked On Agent Name at location:"+index);
	}

	public void mouseEntered(MouseEvent evt)
	{
	}

	public void mousePressed(MouseEvent evt)
	{
	}

	public void mouseReleased(MouseEvent evt)
	{
	}

	public void mouseExited(MouseEvent evt)
	{
	}
}
	
