/**
Class InfoAgent:
An agent which goes to the bank and the telephone company and obtains information.
Note: DB has to be connected at both these places for the operation to be successful
*/


import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.swing.*;
import java.awt.swing.event.*;
import java.security.*;


public class InfoAgent extends Agent implements Serializable
{
	String agentName;
	String agentOrganization;
	String agentPreviousLocation;
	String agentOriginLocation;
	Vector agentHostList;

	//Required parameters for the User's agent
	String socialSecurityNumber;
	String accountNumber;
	String lastName;
	String firstName;
	String address;
	double balance;
	String phoneAccountNumber;
	double phoneBalance;
	boolean ok = false;
	boolean ok1 = false;

	// Security objects
	byte messageDigest[]=null;
	PublicKey publicKey=null;
	byte signature[]=null;

	// constructor
	public InfoAgent()
	{
	}

	public InfoAgent(String agentName, String org, String ownName, Vector list, String accountNumber, String phoneAccountNumber, String lastName, String firstName)
	{
		
		this.agentName=agentName;
		this.agentOrganization=org;
		this.agentPreviousLocation=ownName;
		this.agentHostList=list;
		this.agentOriginLocation=ownName;

		this.accountNumber = accountNumber;
		this.lastName = lastName;
		this.firstName = firstName;
		this.phoneAccountNumber = phoneAccountNumber;
	}


	public void tellData()
	{
		System.out.println("Agent Data:\n"+agentName+"\n"+agentOrganization+"\n"+agentPreviousLocation+"\n"+agentOriginLocation+"\n");
	}

	public String getAgentName() 
	{
		return agentName;
	}

	public String getAgentOrganization()
	{
		return agentOrganization;
	}

	public String getAgentOrigin()
	{
		return agentOriginLocation;
	}

	public String getAgentPreviousLocation()
	{
		return agentPreviousLocation;
	}

	public String getNextHostAddressForDispatch()
	{
			String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return null;
		}

		try
		{
			next=(String) agentHostList.firstElement();
			agentHostList.removeElementAt(0);
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public String getNextHostAddress()
	{
		String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return agentOriginLocation;
		}

		try
		{
			next=(String) agentHostList.firstElement();
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public void showResults()
	{

		Double bal = new Double(balance);
		String newbal = bal.toString();
		Double pBal = new Double(phoneBalance);
		String pString = pBal.toString();
		String colNames[] = {"Social Security No.", "Account No.", "Last Name", "First Name", " Address", "Balance"};
		String row[][] = {
								{"Social Security No.", "Account No.", "Last Name", "First Name", " Address", "BankBal."},
								{" "," "," "," "," "," "},
								{socialSecurityNumber, accountNumber, lastName, firstName, address, newbal}
							
								};

		String row1[][] = {
								{"Social Security No.", "Account No.", "Last Name", "First Name", " Address", "PhoneBal."},
								{" "," "," "," "," "," "},
								{socialSecurityNumber, phoneAccountNumber, lastName, firstName, address, pString}
							
								};

		String msg1, msg2;
		if (ok){msg1 = "Operation successful";}
		else  { msg1 = "Operation failed";}
		if (ok1){msg2 = "Operation successful";}
		else  { msg2 = "Operation failed";}
			
		JPanel myPanel=new JPanel();
		myPanel.setLayout(new GridLayout(5,1));
		JTable table=new JTable(row,colNames);
		JTable table1 = new JTable(row1, colNames);
		String msg = GlobalValues.lname + "'s Agent reporting";

		Font font = new Font("Serif", Font.BOLD , 22); 
		ImageIcon bankIcon = new ImageIcon("spawnon.gif"); 
		JLabel label=new JLabel(msg); 
		label.setIcon(bankIcon);
		label.setFont(font);
        label.setHorizontalAlignment(JLabel.LEFT); 

		Font font1 = new Font("Serif", Font.ITALIC , 18); 
		JLabel label1=new JLabel(msg1); 
		label1.setFont(font1);
        label1.setHorizontalAlignment(JLabel.LEFT); 

		JLabel label2=new JLabel(msg2); 
		label2.setFont(font1);
        label2.setHorizontalAlignment(JLabel.LEFT); 

		myPanel.add(label);
		myPanel.add(table);
		myPanel.add(label1);
		myPanel.add(table1);
		myPanel.add(label2);

		JFrame bankFrame = new JFrame(msg);
		Container c = bankFrame.getContentPane();
		c.setLayout(new FlowLayout());

		bankFrame.setSize(new Dimension(500,300));
		bankFrame.setVisible(true);

		c.add(myPanel);
		bankFrame.show();

	}

	public void tellLocation()
	{}

	public void run() {

		if (this.agentHostList.size() ==1) {
			BankDBHandler Query = new BankDBHandler(lastName, firstName, accountNumber);
			BankDBHandler Detail = Query.GetDetails();
			this.socialSecurityNumber = Detail.ssn;
			this.address = Detail.addr;
			this.balance = Detail.bal;
			this.ok = Detail.ok;
		}
		else if (this.agentHostList.size() == 0) {
			PhoneDBHandler Query1 = new PhoneDBHandler(lastName, firstName, phoneAccountNumber);
			PhoneDBHandler Detail1 = Query1.GetDetails();
			if (this.socialSecurityNumber == null) {this.socialSecurityNumber = Detail1.ssn;}
			if (this.address == null) this.address = Detail1.addr;
			if (this.phoneAccountNumber == null) this.phoneAccountNumber = Detail1.ano;
			this.phoneBalance = Detail1.bal;
			this.ok1 = Detail1.ok;
		}
	}

	public byte[] giveMessageDigest()
	{
		return messageDigest;
	}

	public PublicKey givePublicKey()
	{
		return publicKey;
	}

	public byte[] giveSignature()
	{
		return signature;
	}

	public void signAgent(PublicKey key, byte digest[], byte sign[])
	{
		this.messageDigest=digest;
		this.publicKey=key;
		this.signature=sign;
	}
}

