/**
Class MyAgent
A sample agent which just moves from node to node
*/


import java.io.*;
import java.util.*;
import java.security.*;


public class MyAgent extends Agent implements Serializable
{
	String agentName;
	String agentOrganization;
	String agentPreviousLocation;
	String agentOriginLocation;
	Vector agentHostList;

	// Security objects
	byte messageDigest[];
	PublicKey publicKey;
	byte signature[];


	// constructor
	public MyAgent()
	{
	}

	public MyAgent(String agentName, String org, String ownName, Vector list, String accountNumber, String lastName, String firstName, byte digest[], PublicKey key, byte sign[])
	{
		this.messageDigest=digest;
		this.publicKey=key;
		this.signature=sign;
		this.agentName=agentName;
		this.agentOrganization=org;
		this.agentPreviousLocation=ownName;
		this.agentHostList=list;
		this.agentOriginLocation=ownName;
	}


	public void tellData()
	{
	}

	public String getAgentName() 
	{
		return agentName;
	}

	public String getAgentOrganization()
	{
		return agentOrganization;
	}

	public String getAgentOrigin()
	{
		return agentOriginLocation;
	}

	public String getAgentPreviousLocation()
	{
		return agentPreviousLocation;
	}

	public String getNextHostAddressForDispatch()
	{
		String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return null;
		}

		try
		{
			next=(String) agentHostList.firstElement();
			agentHostList.removeElementAt(0);
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public String getNextHostAddress()
	{
		String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return agentOriginLocation;
		}

		try
		{
			next=(String) agentHostList.firstElement();
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public void run()
	{
		System.out.println("Agent is running");
			
	}

	public void showResults()
	{
		System.out.println("Agent Is Showing Results...");
	}

	public void tellLocation()
	{
		System.out.println("Location not known at the moment");
	}

	public byte[] giveMessageDigest()
	{
		return messageDigest;
	}

	public PublicKey givePublicKey()
	{
		return publicKey;
	}

	public byte[] giveSignature()
	{
		return signature;
	}

	public void signAgent(PublicKey key, byte digest[], byte sign[])
	{
		this.messageDigest=digest;
		this.publicKey=key;
		this.signature=sign;
	}

}

