/**
Class: PhoneDBHandler
	   The agent arriving at the phone company calls this class when it needs to query the bank
	   database.
	   You will need to install a ODBC engine called 'agent' to handle the Access database.
	   You need to provide Lasst name, First name and Account Number to access the account.
  */

import java.net.URL;
import java.sql.*;
     
public class PhoneDBHandler {

	//Data members
	public String lname = null;
	public String fname = null;
	public String ano = null;
	public String ssn = null;
	public String addr = null;
	public double bal = 0.0;

	boolean ok = true;

	//Constructors
	public PhoneDBHandler() {
	}

	public PhoneDBHandler(String ln, String fn, String a) {
		lname = ln;
		fname = fn;
		ano = a;
	}

	//Returns the balance of an account
	public double GetAccountBalance() {
		  
		String url = "jdbc:odbc:agent";
		Connection con;
		String queryString;
		queryString = "SELECT Balance FROM PhoneDB WHERE LastName = '" + lname + "' AND FirstName = '" + fname + "' AND ACN = '" + ano + "'";
		Statement stmt;
	
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

		} catch(java.lang.ClassNotFoundException e) {
			System.err.print("ClassNotFoundException: "); 
			System.err.println(e.getMessage());
			ok = false;
		}

		try {
			con = DriverManager.getConnection(url, "sandeep", "sanishm");
			stmt = con.createStatement();							
	   		ResultSet rs = stmt.executeQuery(queryString);
			while(rs.next()) {
				bal = rs.getDouble(1);
			}
			stmt.close();
			con.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
			ok = false;
		}
		return bal;
	}

	//If add is set to true, increase balance amount otherwise reduce amount
	public boolean ChangeAmount(boolean add, double change) {
		  
		String url = "jdbc:odbc:agent";
		Connection con;
		String updateString;

		double b = GetAccountBalance();
		double newbal;
		if (add)
			newbal = b + change;
		else
			newbal = b - change;
		updateString = "UPDATE PhoneDB SET Balance = ? WHERE LastName = ? AND FirstName = ? AND ACN = ?";
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

		} catch(java.lang.ClassNotFoundException e) {
			System.err.print("ClassNotFoundException: "); 
			System.err.println(e.getMessage());
			ok = false;
		}

		try {
			con = DriverManager.getConnection(url, "sandeep", "sanishm");
			PreparedStatement st = con.prepareStatement(updateString);							
	   		st.setDouble(1, newbal);
			st.setString(2, lname);
			st.setString(3, fname);
			st.setString(4, ano);
			st.executeUpdate();
			System.out.println("Updated to " + newbal);
			st.close();
			con.commit();
			con.close();
	
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
			ok = false;
		}
		return ok;
	}

	//Returns the entire details of an account
	public PhoneDBHandler GetDetails() {
		  
		String url = "jdbc:odbc:agent";
		Connection con;
		String queryString;
		queryString = "SELECT * FROM PhoneDB WHERE LastName = '" + lname + "' AND FirstName = '" + fname + "' AND ACN = '" + ano + "'";
		Statement stmt;
		PhoneDBHandler Details = new PhoneDBHandler();
		Details.lname = lname;
		Details.fname = fname;
		Details.ano = ano;

		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

		} catch(java.lang.ClassNotFoundException e) {
			System.err.print("ClassNotFoundException: "); 
			System.err.println(e.getMessage());
			Details.ok = false;
		}

		try {
			con = DriverManager.getConnection(url, "sandeep", "sanishm");
			stmt = con.createStatement();							
	   		ResultSet rs = stmt.executeQuery(queryString);
			while(rs.next()) {
				Details.ssn = rs.getString(1);
				Details.addr = rs.getString(5);
				Details.bal = rs.getDouble(6);
			}
			stmt.close();
			con.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
			Details.ok = false;
		}
		return Details;
	}
}
