/**
Class TransferAgent
Agent responsible for doing transaction for the user at th bank
*/


import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.swing.*;
import java.awt.swing.event.*;
import java.security.*;

public class TransferAgent extends Agent implements Serializable
{
	String agentName;
	String agentOrganization;
	String agentPreviousLocation;
	String agentOriginLocation;
	Vector agentHostList;
	boolean ok = true;
	boolean less = false;

	// Security objects
	byte messageDigest[]=null;
	PublicKey publicKey=null;
	byte signature[]=null;


	//Required parameters for the User's Transaction agent
	String accountNumber;
	String lastName;
	String firstName;
	double deduct;

	String phoneLastName = "AT&T";
	String phoneFirstName = "Corporation";
	String phoneAcno = "67890";


	public TransferAgent(String agentName, String org, String ownName, Vector list, String accountNumber, String lastName, String firstName, double deduct)
	{
		this.agentName=agentName;
		this.agentOrganization=org;
		this.agentPreviousLocation=ownName;
		this.agentHostList=list;
		this.agentOriginLocation=ownName;

		this.accountNumber = accountNumber;
		this.lastName = lastName;
		this.firstName = firstName;
		this.deduct = deduct;
	}


	public void tellData()
	{
		System.out.println("Agent Data:\n"+agentName+"\n"+agentOrganization+"\n"+agentPreviousLocation+"\n"+agentOriginLocation+"\n");
	}

	public String getAgentName() 
	{
		return agentName;
	}

	public String getAgentOrganization()
	{
		return agentOrganization;
	}

	public String getAgentOrigin()
	{
		return agentOriginLocation;
	}

	public String getAgentPreviousLocation()
	{
		return agentPreviousLocation;
	}

	public String getNextHostAddressForDispatch()
	{
		String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return null;
		}

		try
		{
			next=(String) agentHostList.firstElement();
			agentHostList.removeElementAt(0);
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public String getNextHostAddress()
	{
		String next=null;

		if (agentHostList.isEmpty())
		{
			// If no more destinations then return the origin location for the agent
			return agentOriginLocation;
		}

		try
		{
			next=(String) agentHostList.firstElement();
		}
		catch (NoSuchElementException e)
		{
			System.out.println("MyAgent ERROR: No such element");
			return null;
		}
		catch (ArrayIndexOutOfBoundsException e1)
		{
			System.out.println("My Agent ERROR:Array Index Out of bounds");
			return null;
		}

		return next;
	}

	public void showResults()
	{

		String output = null;
		JPanel myPanel=new JPanel();
		myPanel.setLayout(new GridLayout(2,1));
		String msg = GlobalValues.lname + "'s Agent reporting";
		if (ok) {
			output = "Operation successful. $"+deduct+" was transferred to phone company";
		}
		else if (less){
			output = "Not sufficient balance in bank to pay the phone bill. Mission failed";
		}
		else {
			output = "I failed in my mission. I could not transfer $"+deduct+" to the phone company";
		}

		Font font = new Font("Serif", Font.BOLD , 22); 
		ImageIcon bankIcon = new ImageIcon("spawnon.gif"); 
		JLabel label=new JLabel(msg); 
		label.setFont(font);
		label.setIcon(bankIcon);
        label.setHorizontalAlignment(JLabel.LEFT); 

		Font font1 = new Font("Serif", Font.ITALIC , 18); 
		JLabel label1=new JLabel(output); 
        label1.setHorizontalAlignment(JLabel.LEFT); 
		label1.setFont(font1);

		myPanel.add(label);
		myPanel.add(label1);

		JFrame bankFrame = new JFrame(msg);
		Container c = bankFrame.getContentPane();
		c.setLayout(new FlowLayout());

		bankFrame.setSize(new Dimension(500,200));
		bankFrame.setVisible(true);

		c.add(myPanel);
		bankFrame.show();

	}

	public void tellLocation() {
	}

	public void run() {

		boolean success = false, moreSuccess = false;

		BankDBHandler Reduce = new BankDBHandler(lastName, firstName, accountNumber);
		success = Reduce.ChangeAmount(false, deduct);
		less = Reduce.less;
		if (!(less)) {
			BankDBHandler Add = new BankDBHandler(phoneLastName, phoneFirstName, phoneAcno);
			moreSuccess = Add.ChangeAmount(true, deduct);
		}
		if ((success) && (moreSuccess)) {ok = true;} else {ok = false;}
	}

	public byte[] giveMessageDigest()
	{
		return messageDigest;
	}

	public PublicKey givePublicKey()
	{
		return publicKey;
	}

	public byte[] giveSignature()
	{
		return signature;
	}

	public void signAgent(PublicKey key, byte digest[], byte sign[])
	{
		this.messageDigest=digest;
		this.publicKey=key;
		this.signature=sign;
	}
}

